from unittest.mock import patch
from iocage_lib.ioc_common import get_host_gateways


@patch('iocage_lib.ioc_common.checkoutput')
def test_01_get_host_gateways(mock_checkoutput):
    mock_checkoutput.side_effect = [netstat_output]
    assert get_host_gateways() == \
        {'ipv4': {'gateway': '217.29.43.254', 'interface': 'inet0'},
         'ipv6': {'gateway': 'fe80::8%inet0', 'interface': 'inet0'}}


netstat_output = '{"statistics": {"route-information": {"route-table": {"rt-family": [{"address-family":"Internet", "rt-entry": [{"destination":"default","gateway":"217.29.43.254","flags":"UGS", "flags_pretty": ["up","gateway","static"],"interface-name":"inet0"}, {"destination":"10.5.0.0/16","gateway":"link#5","flags":"U", "flags_pretty": ["up"],"interface-name":"mgmt0"}, {"destination":"10.5.105.29","gateway":"link#5","flags":"UHS", "flags_pretty": ["up","host","static"],"interface-name":"lo0"}, {"destination":"127.0.0.1","gateway":"lo0","flags":"UHS", "flags_pretty": ["up","host","static"],"interface-name":"lo0"}, {"destination":"217.29.42.0/23","gateway":"link#4","flags":"U", "flags_pretty": ["up"],"interface-name":"inet0"}, {"destination":"217.29.42.186","gateway":"link#4","flags":"UHS", "flags_pretty": ["up","host","static"],"interface-name":"lo0"}]}, {"address-family":"Internet6", "rt-entry": [{"destination":"::/96","gateway":"::1","flags":"UGRS", "flags_pretty": ["up","gateway","reject","static"],"interface-name":"lo0"}, {"destination":"default","gateway":"fe80::8%inet0","flags":"UGS", "flags_pretty": ["up","gateway","static"],"interface-name":"inet0"}, {"destination":"::1","gateway":"lo0","flags":"UHS", "flags_pretty": ["up","host","static"],"interface-name":"lo0"}, {"destination":"::ffff:0.0.0.0/96","gateway":"::1","flags":"UGRS", "flags_pretty": ["up","gateway","reject","static"],"interface-name":"lo0"}, {"destination":"2a00:b580:8000:8::/64","gateway":"link#4","flags":"U", "flags_pretty": ["up"],"interface-name":"inet0"}, {"destination":"2a00:b580:8000:8:9d6:2f93:3504:d4c9","gateway":"link#4","flags":"UHS", "flags_pretty": ["up","host","static"],"interface-name":"lo0"}, {"destination":"fe80::/10","gateway":"::1","flags":"UGRS", "flags_pretty": ["up","gateway","reject","static"],"interface-name":"lo0"}, {"destination":"fe80::%lo0/64","gateway":"link#3","flags":"U", "flags_pretty": ["up"],"interface-name":"lo0"}, {"destination":"fe80::1%lo0","gateway":"link#3","flags":"UHS", "flags_pretty": ["up","host","static"],"interface-name":"lo0"}, {"destination":"fe80::%inet0/64","gateway":"link#4","flags":"U", "flags_pretty": ["up"],"interface-name":"inet0"}, {"destination":"fe80::921b:eff:fe63:ef31%inet0","gateway":"link#4","flags":"UHS", "flags_pretty": ["up","host","static"],"interface-name":"lo0"}, {"destination":"fe80::%mgmt0/64","gateway":"link#5","flags":"U", "flags_pretty": ["up"],"interface-name":"mgmt0"}, {"destination":"fe80::921b:eff:fe63:f359%mgmt0","gateway":"link#5","flags":"UHS", "flags_pretty": ["up","host","static"],"interface-name":"lo0"}, {"destination":"fe80::%vnet0.97/64","gateway":"link#7","flags":"U", "flags_pretty": ["up"],"interface-name":"vnet0.97"}, {"destination":"fe80::1015:29ff:fecd:61a7%vnet0.97","gateway":"link#7","flags":"UHS", "flags_pretty": ["up","host","static"],"interface-name":"lo0"}, {"destination":"ff02::/16","gateway":"::1","flags":"UGRS", "flags_pretty": ["up","gateway","reject","static"],"interface-name":"lo0"}]}]}}}}'
